routes/web.php
<?php

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;


Auth::routes();

//Landing Page
Route::get('/', function () {
    return view('welcome');
});

//minimum user / logged in user
Route::group(['middleware' => ['level:1']], function () {
    //minimum Teacher
    Route::group(['middleware' => ['level:4']], function () {
        Route::group(['middleware' => ['level:5']], function () {
        });
        Route::resource('courses', 'CoursesController');
        Route::resource('courses.assignments', 'AssignmentController');
        Route::resource('courses.assignments.handin','HandinController');
        Route::resource('courses.assignments.handin.grade','GradeController');
        Route::get('courses/{course}/assignments/{assignment}/handin/{handin}/download','HandinController@downloadhandin')->name('course.assignments.handin.download');
        Route::resource('video','VideoController');
        Route::resource('users', 'UserController');

    });

    Route::resource('dashboard', 'DashboardController');

    Route::resource('forum', 'ForumController', ['except' => ['show']])->parameters(['forum' => 'category']);
    Route::resource('forum.topic', 'ForumTopicController')->parameters(['forum' => 'category']);
    Route::resource('forum.topic.post', 'ForumTopicPostController')->parameters(['forum' => 'category']);

    Route::resource('courses', 'CoursesController', ['only' => ['index']]);

    Route::resource('courses.assignments', 'AssignmentController', ['only' => ['index','show']]);
    Route::resource('courses.assignments.handin','HandinController', ['only' => ['create','store']]);

    Route::get('courses/{course}/assignments/{assignment}/handin/{handin}/download','HandinController@downloadhandin')->name('course.assignments.handin.download');

    Route::resource('profile', 'ProfileController');
    Route::resource('dashboard', 'DashboardController');
    Route::resource('contact','ContactController');
    Route::post('search', 'DashboardController@search')->name('search');

    Route::resource('videos', 'VideoController');

    //botman routes
    Route::match(['get', 'post'], '/botman', 'BotManController@handle');
});

app/Assignment.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Spatie\Searchable\Searchable;
use Spatie\Searchable\SearchResult;

class Assignment extends Model implements Searchable
{
    public function course()
    {
        return $this->belongsTo(Course::class);
    }


    /**
     * @return SearchResult
     */
    public function getSearchResult(): SearchResult
    {
        $url = route('courses.assignments.show', [$this->course, $this->id]);

        return new SearchResult(
            $this,
            $this->course->name . " - " . $this->name,
            $url
        );
    }

    public function handins(){
        return $this->hasMany(Handin::class,'assignment_id');
    }

}

app/Http/Controllers/AssignmentController.php
<?php

namespace App\Http\Controllers;

use App\Assignment;
use App\Course;
use App\Handin;
use App\Http\Requests\CreateAssignmentRequest;
use App\User;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class AssignmentController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @param Course $course
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function index(Course $course)
    {
        $locked = [];
        if (Auth::user()->hasRole('admin|teacher')) {
            $assignments = $course->assignments;
        } else {
            $assignments = $course->assignments->filter(function ($assignment, $key) use (&$locked) {
                if ($assignment->unlock_after_assignment_id == null) return true;
                $toCheck = Assignment::find($assignment->unlock_after_assignment_id);
                $handin = $toCheck->handins()->where('user_id', Auth::id())->first();
                if ($handin != null)
                    return true;
                $locked[$assignment->id] = $assignment;
                return false;
            });
        }

        return view('assignments.index', ['assignments' => $assignments, 'locked' => $locked, 'course' => $course]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @param Course $course
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function create(Course $course)
    {
        $assignments = Assignment::pluck('name', 'id');
        return view('assignments.create', ['course' => $course, 'assignments' => $assignments]);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param CreateAssignmentRequest $request
     * @param Course $course
     * @return \Illuminate\Http\RedirectResponse
     */
    public function store(CreateAssignmentRequest $request, Course $course)
    {
        if (!$request->validated()) {
            return redirect()->back()->withInput($request->input())->withErrors($request);
        }

        $assignment = new Assignment();
        if ($request->file('video') != null) {
            $video = $request->file('video')->store('/public/videos');
            $video = str_replace('public/videos/', '', $video);
            $assignment->video = $video;
        }
        $assignment->course_id = $course->id;
        $assignment->name = $request['name'];
        $assignment->description = $request['description'];
        $assignment->unlock_after_assignment_id = $request['unlock_after_assignment_id'];
        $assignment->save();
        return redirect()->route('courses.assignments.index', ['course' => $course->id]);
    }

    /**
     * Display the specified resource.
     * @param Course $course
     * @param \App\Assignment $assignment
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */

    public function show(Course $course, Assignment $assignment)
    {
        if ($assignment->unlock_after_assignment_id != null) {
            $check = Assignment::find($assignment->unlock_after_assignment_id)->handins()->where('user_id', Auth::id())->first();
            if ($check != null) {
                $handins = $assignment->handins()->where('user_id', Auth::id())->first();
                return view('assignments.show', ['course' => $course, 'assignment' => $assignment, 'handin' => $handins, 'user' => Auth::user()]);
            }
        } else {
            $handins = $assignment->handins()->where('user_id', Auth::id())->first();
            return view('assignments.show', ['course' => $course, 'assignment' => $assignment, 'handin' => $handins, 'user' => Auth::user()]);
        }
        return redirect()->route('courses.assignments.index', ['course' => $course]);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param \App\Assignment $assignment
     * @return \Illuminate\Http\Response
     */
    public function edit(Assignment $assignment)
    {

    }

    /**
     * Update the specified resource in storage.
     *
     * @param \Illuminate\Http\Request $request
     * @param \App\Assignment $assignment
     * @param Course $course
     * @return \Illuminate\Http\RedirectResponse
     */
    public function update(CreateAssignmentRequest $request, Course $course, Assignment $assignment)
    {
        if ($request->file('video') != null) {
            $video = $request->file('video')->store('/public/videos');
            $video = str_replace('public/videos/', '', $video);
            $assignment->video = $video;
        }
        $assignment->name = $request['name'];
        $assignment->description = $request['description'];
        $assignment->unlock_after_assignment_id = $request['unlock_after_assignment_id'];
        $assignment->save();
        return redirect()->route('courses.assignments.index', $course);
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param Course $course
     * @param Assignment $assignment
     * @return \Illuminate\Http\RedirectResponse
     * @throws \Exception
     */
    public function destroy(Course $course, Assignment $assignment)
    {
        $assignment->delete();
        return redirect()->route('courses.assignments.index', ['course' => $course]);
    }
}

resources/views/assignments/create.blade.php
@extends('layouts.dashboard')
@section('content')
    <nav aria-label="breadcrumb">
        <ol class="breadcrumb">
            <li class="breadcrumb-item"><a href="{{route('dashboard.index')}}">Dashboard</a></li>
            <li class="breadcrumb-item"><a href="{{route('courses.index',$course)}}">Courses</a></li>
            <li class="breadcrumb-item"><a href="{{route('courses.assignments.index',$course)}}">Assignments</a></li>
            <li class="breadcrumb-item active" aria-current="page">Create assignments</li>
        </ol>
    </nav>
    <div class="container-sm">
        <h1>New assignment</h1>
        {{ Form::open  (array('route' => array('courses.assignments.store',$course),'method'=>'post','files'=>true,'enctype'=>'multipart/form-data')) }}
        <div class="form-group">
            {{ Form::label('name', 'Name') }}
            {{ Form::text('name',null,array('class'=>'form-control')) }}
            {{ Form::label('description', 'Description') }}
            {{ Form::textarea('description',null,array('class'=>'form-control')) }}<br>
            {{ Form::label('video', 'Upload a Video') }} <br>
            {{ Form::file('video')}}
            <br><br>
            {{ Form::label('unlock_after_assignment_id', 'Unlock after:') }}
            {{ Form::select('unlock_after_assignment_id', [null=>'None'] + $assignments->all(), null, ['class' => 'form-control']) }}

            <br>


            @foreach($errors->all() as $error)
                <p class="text-danger">
                    {{ $error }}
                </p>
            @endforeach
        </div>
        {{Form::submit('Save',array('class'=>'btn btn-primary'))}}
        {{Form::close()}}
    </div>
@endsection

resources/views/assignments/index.blade.php
@extends('layouts.dashboard') @section('content')
    <nav aria-label="breadcrumb">
        <ol class="breadcrumb">
            <li class="breadcrumb-item"><a href="{{route('dashboard.index')}}">Dashboard</a></li>
            <li class="breadcrumb-item"><a href="{{route('courses.index',$course)}}">Courses</a></li>
            <li class="breadcrumb-item active" aria-current="page">Assignments</li>
        </ol>
    </nav>
    <div class="container-sm">
        <h1 class="display-6 ml-4 font-weight-bold text-xl-center text-center mb-5">Assignments</h1>
        @if(Auth::user()->hasRole('admin|teacher'))
            <a class="btn btn-success float-right" href="{{route('courses.assignments.create',$course)}}">Create assignment</a><br />
            <br />
        @endif @foreach($assignments as $assignment)
            <ul class="list-group mt-3">
                @if ($assignment->count())
                    <li class="list-group-item border-0 mb-3 shadow-sm">
                        <span class="font-weight-light mt-4">{{$assignment->name}}</span>
                        <span>
                <a class="btn btn-primary d-flex justify-content-between float-right ml-2" href="{{route('courses.assignments.show',[$course,$assignment])}}">Go to Assignment</a>
                @if(Auth::user()->hasRole('admin|teacher'))
                                <button class="btn btn-danger float-right" type="button" data-toggle="collapse" data-target="#multiCollapseExample{{$assignment->id}}" aria-expanded="false" aria-controls="multiCollapseExample{{$assignment->id}}">
                    Edit
                </button>
                                <br />
                                <br />
                                <div class="collapse multi-collapse" id="multiCollapseExample{{$assignment->id}}">
                    <div class="card card-body">
                        <div class="row">
                            <div class="col-sm-6">
                                {{ Form::model($assignment, array('route' => array('courses.assignments.update',[$course,$assignment]),'method'=>'put','files'=>true,'class'=>'form-group')) }} {{ Form::label('name',
                                'Name:',array('class'=>'mr-2')) }} {{ Form::text('name',null,array('class'=>'form-control mb-2')) }} {{ Form::label('description', 'Description:') }} {{
                                Form::textarea('description',null,array('class'=>'form-control mb-2','rows' => 1)) }}
                                <br />
                                {{ Form::label('video', 'Upload video') }} {{ Form::file('video',null,array('class'=>'form-control '))}}
                                <br />
                                <br />
                                {{ Form::label('unlock_after_assignment_id', 'Unlock after:') }} {{ Form::select('unlock_after_assignment_id', [null=>'None'] + $assignments->reject($assignment)->pluck('name','id')->all(), null, ['class' =>
                                'form-control mb-2']) }} @foreach($errors->all() as $error)
                                    <p class="text-danger">
                                    {{ $error }}
                                </p>
                                @endforeach {{Form::submit('Save',array('class'=>'btn btn-primary float-left ml-2'))}} {{Form::close()}}

                            </div>
                            <div class="col-sm-6">
                            @if(isset($assignment->video))
                                <form action="{{route('video.update',$assignment->id)}}" method="post">@csrf @method('PUT') <button class="btn btn-danger" type="submit">Delete existing Video</button> </form>

                                @endif
                                                         <form style="position: absolute; bottom: 0;" action="{{route('courses.assignments.destroy',[$course,$assignment])}}" method="post">
                                    @csrf @method('DELETE')<button type="submit" class="btn btn-danger float-right">Delete</button>
                                </form>
                            </div>
                        </div>
                    </div>
                </div>
                            @endif
            </span>
                    </li>
                @else
                    <li class="list-group-item border-0 mb-3 shadow-sm">
                        There are no assignments available.
                    </li>
                @endif
            </ul>
        @endforeach @foreach($locked as $assignment)
            <ul class="list-group mt-3">
                @if ($assignment->count())
                    <li class="list-group-item border-0 mb-3 shadow-sm">
                        <span class="font-weight-light mt-4">{{$assignment->name}}</span>
                        <span>
                <a class="btn btn-danger d-flex justify-content-between float-right ml-2 text-white">Locked by {{$assignment->find($assignment->unlock_after_assignment_id)->name}}</a>
            </span>
                    </li>
                @else
                    <li class="list-group-item border-0 mb-3 shadow-sm">
                        There are no more locked assignments.
                    </li>
                @endif
            </ul>
        @endforeach
    </div>
@endsection

resources/views/assignments/show.blade.php
@extends('layouts.dashboard')
@section ('title', 'Assignments |' . $assignment->name)
@section('content')
    <nav aria-label="breadcrumb">
        <ol class="breadcrumb">
            <li class="breadcrumb-item"><a href="{{route('dashboard.index')}}">Dashboard</a></li>
            <li class="breadcrumb-item"><a href="{{route('courses.index',$course)}}">Courses</a></li>
            <li class="breadcrumb-item"><a href="{{route('courses.assignments.index',$course)}}">Assignments</a></li>
            <li class="breadcrumb-item active" aria-current="page">Assignment overview</li>
        </ol>
    </nav>
    <div class="container">
        <div class="row">
            <div class="col-12 col-sm-10 col-lg-6 mx-auto">
                <h1 class="display-4" style="text-align: center; margin: 50px 0;">Assignment</h1>
                <div class="form-group py-3 px-4 shadow rounded">
                    @if(isset($handin->grade->id)&&$user->hasRole('user')&&$user->id==Auth::id())
                        <p class="font-weight-bold float-right" style="font-size: 24px;">Grade: {{$handin->grade->grade}}</p>
                    @endif
                    <label for="title "><h4 class="font-weight-bold">Title:</h4></label>
                    <p>{{$assignment->name}}</p>
                    <label for="Description"><h4 class="font-weight-bold">Description:</h4></label>
                    <p>{{$assignment->description}}</p>
                    @if($assignment->video)
                        <h4 class="font-weight-bold">Video:</h4>
                            <video width="320" height="auto" controls>
                            <source src="/storage/videos/{{$assignment->video}}" type="video/mp4">
                            Your browser does not support the video tag.
                        </video>
                        <br><br>
                    @endif
                    @if(isset($handin->id)&&$handin->user_id == Auth::id()&&$user->hasRole('user'))
                        <div style="padding:5px 0 15px 0;">
                            <a class="btn btn-success" href="{{route('course.assignments.handin.download',[$course,$assignment,$handin])}}">Download submitted assignment</a>
                        </div>
                    @elseif(!$user->hasRole('admin|teacher'))
                        <div style="padding:5px 0 15px 0">
                            <a class="btn btn-success float-left" href="{{route('courses.assignments.handin.create',[$course,$assignment])}}">Handin assignment</a>
                        </div>
                        <br><br>
                    @endif
                    @if(isset($handin->grade->id)&&$user->hasRole('user'))
                        <div class="card">
                            <div class="card-body">
                                <p class="font-weight-bold float-right" style="font-size: 20px;">Comment: {{$handin->grade->comment}} &nbsp;</p>
                            </div>
                        </div>
                    @endif
                    @if($user->hasRole('admin|teacher'))
                        <a href="{{route('courses.assignments.handin.index',[$course,$assignment])}}" class="btn btn-primary">View all handins</a>
                    @endif
                </div>
            </div>
        </div>
    </div>
@endsection